# specFlow

This configuration section contains settings related to synchronizing SpecFlow projects. These settings are only required for old SpecFlow versions and for [synchronizing automated test cases](/specsync/important-concepts/synchronizing-automated-test-cases.md).

The following example shows the available options within this section.

```javascript
{
  ...
  "specFlow": {
    "specFlowGeneratorFolder": "..\\packages\\SpecFlow.2.3.0\\tools",
    "generateFeatureFileCodeBehinds": false,
    "scenarioOutlineAutomationWrappers": "iterateThroughExamples",
    "wrapperMethodPrefix": "_SpecSyncWrapper_",
    "wrapperMethodCategory": "SpecSyncWrapper"
  },
  ...
}
```

## Settings

| Setting                             | Description                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       | Default                                                        |
| ----------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | -------------------------------------------------------------- |
| `specFlowGeneratorFolder`           | The path of the SpecFlow generator folder used by the project, that is usually the `tools` folder of the SpecFlow NuGet package, e.g. `packages\\SpecFlow.2.3.0\\tools`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          | detect generator of the project                                |
| `generateFeatureFileCodeBehinds`    | Specifies whether SpecSync should attempt to regenerate feature file code-behind files after they have been changed by SpecSync. This is only required for SpecFlow v2.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           | SpecSync automatically decides whether generation is necessary |
| `scenarioOutlineAutomationWrappers` | <p>Specifies how automation wrapper methods should be generated for synchronizing scenario outlines to automated test cases. Available options: <code>useTestCaseData</code> and <code>iterateThroughExamples</code>. (Default: <code>iterateThroughExamples</code>)</p><ul><li><code>useTestCaseData</code> -- the generated wrapper method loads the test data for the iterations from the test case. Running the test cases through this wrapper in Azure DevOps generates a detailed report about each iteration, but it cannot be executed locally and also does not work in from Azure DevOps pipeline build. See <a href="/pages/-LVwFCM4RFOiqwfKYqFv#use-testcase-data-for-scenario-outline-examples-for-legacy-mstest-v1-projects">related section of the Synchronizing automated test cases article</a> for details.</li><li><code>iterateThroughExamples</code> -- the generated wrapper method iterates through the examples and runs the test for each. A failure of an iteration does not block the remaining iterations. Running the test cases through this wrapper in Azure DevOps generates a single entry in the report, but the details of the entry contain all executed data set.</li></ul> | `iterateThroughExamples`                                       |
| `wrapperMethodPrefix`               | The method prefix to be used for the generated automation wrapper methods.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        | `_SpecSyncWrapper_`                                            |
| `wrapperMethodCategory`             | The test category (trait) be added for the generated automation wrapper methods.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  | `SpecSyncWrapper`                                              |

{% content-ref url="/pages/-LVwFCLiKB3ACJLwVZGP" %}
[Configuration reference](/specsync/reference/configuration.md)
{% endcontent-ref %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.specsolutions.eu/specsync/reference/configuration/configuration-specflow.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
